'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: master.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:36 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : very important routines to start a testscript
'*
'************************************************************************
'*
' Global:
' #1  GetUseFiles             ' First routine which will be called automatically by starting a testscript
' #1  LoadDeclaration         ' Includes the whole declaration (.sid- and .win-files)
' #1  LoadGlobalIncludeFiles  ' Includes global .inc-files
'
' Recover routines:
' #1  TestEnter               ' Internal subroutine called at testcase-start -> start recovering
' #1  TestExit                ' Internal subroutine called at testcase-end
'                               If an error in a testscript occurs the test jumps directly into this routine
' #1  PleaseRecover           ' Recover routine used by TestExit- and TestEnter
'
' Office Startroutines:
' #1  hStartTheOffice         ' Routine to start the Office
' #1  ExitRestartTheOffice    ' Exit and restart the office - after 30 seconds
' #1  FirstOfficeStart        ' First office start with ResetApplication function
'
' Special Information:
' #1  IsDebugVersion           ' bDebugVersion variable will be set TRUE if the office is a debug version
' #1  FindBuildID              ' Scans in iso*.res for the BuildID.
' #1  GetBuildNumHidLst        ' Scans the BuildID in hid.lst
' #1  hFirstOutPut             ' Creates a general information header in result files for all tests
' #1  mMakeGeneralOptions      ' Sets general options in the office
' #0  hDetectMahlerFramework   ' Detecting the mahler TT Framework server
'*
'\***********************************************************************

sub GetUseFiles
'///<i>GetUseFiles</i>: The first routine which will be called automatically by starting a testscript.
'/// Include all important libraries (.inc) for the startup.
   use "global\system\inc\sysinfo.inc"     '///+ sysinfo.inc  : routines to get all system informations
   use "global\system\inc\inivalue.inc"    '///+ inivalue.inc : routines to work with ini-files
   use "global\system\inc\iniinfo.inc"     '///+ iniinfo.inc  : routines to get all informations about StarOffice
   use "global\system\inc\status.inc"      '///+ status.inc   : all routines to put the status-info into database
   use "global\tools\inc\t_xml1.inc"       '///+ t_xml1.inc   : XML-parse-routines

'/// Call important system- and start-routines.
   Call LoadDeclaration                  '///+<ul><li><b>LoadDeclaration</b>: Load all declaration files (master.inc)</li>
   Call LoadGlobalIncludeFiles           '///+<li><b>LoadGlobalIncludeFiles</b>: Include file with global routines (master.inc)</li>

   Call GetToolPlatform                  '///+<li><b>GetToolPlatform</b>: Detect operating environment for the Testtool (sysinfo.inc)</li>
   Call GetOfficePlatform                '///+<li><b>GetOfficePlatform</b>: Detect operating environment for the office (sysinfo.inc)</li>
   Call GetIniInformation                '///+<li><b>GetIniInformation</b>: Get all information out of the <i>testtool.ini/.testtoolrc</i> and set it on global variables (iniinfo.inc)</li>
   Call GetOfficeInformation             '///+<li><b>GetOfficeInformation</b>: Set <i>sAppExe</i> for startup</li>
   Call FirstOfficeStart                 '///+<li><b>FirstOfficeStart</b>: Try to start the office for first time (master.inc)</li>
   Call GetLanguageInformation           '///+<li><b>GetLanguageInformation</b>: Detect the language of office (iniinfo.inc)</li>
   Call hFirstOutput                     '///+<li><b>hFirstOutput</b>: Make last adjustments and creat information output (master.inc)</li>

'/// make some default setting
   gNoNewDoc = FALSE                     'OBSOLETE: gNoNewDoc = FALSE: Set default to create 'no new document' to FALSE (feature has been used for Portal-/WebTop)
   gProflog  = FALSE                     '///+<li>gProflog  = FALSE: Set default for getting profiling data to FALSE
   Call mMakeGeneralOptions              '///+<li><b>mMakeGeneralOptions</b></li>: Set general options <ol><li><u>system-file-dialogs off</u> on Win32</li><li>work-dir to internal ../user/work-dir</li></ol></li>

   printlog ""
   Call GetDefaultFilternames            '///+<li><b>GetDefaultFilternames</b>: Get the correct <u>default names for filters</u> for each application</li></ul>
end sub

'-------------------------------------------------------------------------

sub LoadDeclaration
'/// Include all .sid-declarations (all menu-items as SlotIDs)
'///+&lt;German names&gt; (<u><b>OBSOLETE</u>, only fixes allowed!</b>)
   use "global\sid\all.sid"          '///+<ul><li>all.sid: All menuitems (German)</li>
   use "global\sid\bars.sid"         '///+<li>leisten.sid: All toolbars and toolboxes (German)</li>
   use "global\sid\context.sid"      '///+<li>kontext.sid: All context menus</li>
   use "global\sid\others.sid"       '///+<li>allgem.sid: other slots (German)</li></ul>
'///&lt;English names&gt;
   use "global\sid\e_all.sid"        '///+<ul><li>e_all.sid : all menuitems</li></ul>

'/// Include all .win-declarations (all dialogs as HelpIDs)
'///+&lt;German names&gt; (<u><b>OBSOLETE</u>, only fixes allowed!</b>)
   use "global\win\tab_a_d.win"      '///+<ul><li>All tabpages A...Z</li>
   use "global\win\tab_e_g.win"
   use "global\win\tab_h_o.win"
   use "global\win\tab_p_s.win"
   use "global\win\tab_t_z.win"

   use "global\win\dial_a_c.win"     '///+<li>All dialogs A...Z</li>
   use "global\win\dial_d_h.win"
   use "global\win\dial_i_o.win"
   use "global\win\dial_p_s.win"
   use "global\win\dial_t_z.win"

   use "global\win\sys_dial.win"     '///+<li>sys_dial.win: Systemdialogs</li>
   use "global\win\dokument.win"     '///+<li>dokument.win: All document-types</li>
   use "global\win\mathop.win"       '///+<li>mathop.win: Windows with all math operators</li>

   use "global\win\piloten.win"      '///+<li>piloten.win: Database-, Impress-, Microsoft(R) import-autopilots</li>
   use "global\win\w_autop.win"      '///+<li>w_autop.win: All Writer autopilots</li>

   use "global\win\leisten.win"      '///+<li>leisten.win: All toolbars as windows</li>
   use "global\win\toolbox.win"      '///+<li>toolbox.win: Toolboxes as windows</li></ul>

'///&lt;English names&gt;
   use "global\win\edia_a_c.win"     '///+<ul><li>All dialogs A...Z</li>
   use "global\win\edia_d_h.win"
   use "global\win\edia_i_o.win"
   use "global\win\edia_p_s.win"
   use "global\win\edia_t_z.win"

   use "global\win\etab_a_d.win"     '///+<li>All tabpages A...Z</li>
   use "global\win\etab_e_g.win"
   use "global\win\etab_h_o.win"
   use "global\win\etab_p_s.win"
   use "global\win\etab_t_z.win"

   use "global\win\e_mathop.win"     '///+<li>e_mathop.win: Mathoperators</li>

   use "global\win\bars.win"         '///+<li>bars.win:  All bars as windows</li>
   use "global\win\etoolbox.win"     '///+<li>etoolsbox.win: Toolboxes</li></ul>
end sub

'-------------------------------------------------------------------------

sub LoadGlobalIncludeFiles
'///Load all important global files.
   use "global\tools\inc\t_files.inc"        '///+<ul><li><b>t_files</b>: Routines to open/save/print files</li>
   use "global\tools\inc\t_dir.inc"          '///+<li><b>t_dir</b>: Routines to parse directories (methods execute on the office side)</li>
   use "global\tools\inc\t_dirloc.inc"       '///+<li><b>t_dirloc</b>: Routines to parse directories (execute on the testtool side)</li>
   use "global\tools\inc\t_doc1.inc"         '///+<li><b>t_doc1</b>: Global routines to work on office documents (I)</li>
   use "global\tools\inc\t_doc2.inc"         '///+<li><b>t_doc2</b>: Global routines to work on office documents (II)</li>
   use "global\tools\inc\t_menu.inc"         '///+<li><b>t_menu</b>: Routines to work with menus in the office</li>
   use "global\tools\inc\t_lists.inc"        '///+<li><b>t_lists</b>: Work with array/lists in basic scripts</li>
   use "global\tools\inc\t_option.inc"       '///+<li><b>t_option</b>: Routine to navigate in the options-dialoge of office (I)</li>
   use "global\tools\inc\t_option2.inc"      '///+<li><b>t_option2</b>: Routine to navigate in the options-dialoge of office (II)</li>
   use "global\tools\inc\t_tools1.inc"       '///+<li><b>t_tools1</b> : Global routines (I)</li>
   use "global\tools\inc\t_tools2.inc"       '///+<li><b>t_tools1</b>: Global routines (II)</li></ul>
end sub

'-------------------------------------------------------------------------

sub FirstOfficeStart
'/// First start-routine.
   caselog ""                   '///+<ul><li>Stop the first default-output into the resultfile</li>
   Call hStartTheOffice         '///+<li>Start the office</li>
   ResetApplication             '///+<li>Make the first recovering without an error output.</li></ul>
end sub

'-------------------------------------------------------------------------

sub hStartTheOffice (optional sProfPath as String, optional sProfParameter as String)
  Dim sSTSfile as String
  Dim sWorkAround as string
'///hStartTheOffice
'///+<ul><li><u>input</u>: <b>optional</b> <i>sProfPath</i> as String [path for profiling data]</li>
'///+<li><u>input</u>: <b>optional</b> <i>sProfParameter</i> as String [filename for profiling data]</li></ul>

'///+<ol><li>Be sure the path to the result file exists and is writeable
'///+<ul><li>If it doesn't exist, try to create it</li>
'///+<li>If it isn't writeable a messagebox will be thrown</li>
'///+<li>The test will be stopped because without this path the testtool cannot write the resultfile to disk</li></ul></li>
   if (hIsResultWriteable() <> TRUE) then
      if MsgBox ("The test won't start; please correct the error of the not createable RESULT file!", 16, "Error at startup") = 1 then end
   endif
'Startroutine for soffice.exe
'///+<li>Search for <i>sts-file</i> (libsts???xx.so or sts???mi.dll)
'///+<ul><li>If it doesn't exist a messagebox will be thrown</li>
'///+<li>The test will be stopped because without that sts-file the Testtool can not connect to the office.</li></ul></li>
    if gSamePC = TRUE then
       if gPlatgroup = "unx" then
          if gNetzInst = TRUE then
             sSTSfile = gNetzOfficePath + "program/libsts*.so"
          else
             sSTSfile = gOfficePath + "program/libsts*.so"
          end if

          if dir (sSTSfile) = "" then
             warnlog "'libsts*.so' was not found at '" + sSTSfile + "'."
             warnlog "Please copy the correct file into the program-dir of StarOffice!"
             if MsgBox ("'libsts*.so' was not found at '" + sSTSfile + "'" +Chr(10)+ "Testtool cannot connect to StarOffice!" + Chr(10) + "Please copy the correct libsts*.so into program-dir of StarOffice.", 17, "Error at startup") = 2 then end
          end if
       else
          if gNetzInst = TRUE then
             sSTSfile = gNetzOfficePath + "program\sts*.dll"
          else
             sSTSfile = gOfficePath + "program\sts*.dll"
          end if

          if dir (sSTSfile) = "" then
             warnlog "'sts*mi.dll' was not found at '" + sSTSfile + "'."
             warnlog "Please copy the correct file into the program-dir of StarOffice!"
             if MsgBox ("'sts*mi.dll' was not found at '" + sSTSfile + "'" +Chr(10)+ "Testtool cannot connect to StarOffice!" + Chr(10) + "Please copy the correct sts*mi.dll into program-dir of StarOffice.", 17, "Error at startup") = 2 then end
          end if
       end if
    end if
'///+<li>If a Sun(TM) ONE Webtop client should be tested
'///+<ul><li>First, the normal start-instruction will be tried (to connect to a running office-process)</li>
'///+<li>If no process is running a shell instruction will be called with the startup call</li></ul></li>
    if gClient = TRUE AND gClientUser <> "" then
       try
          start sAppExe, sAppParameter        ' you can't start a client with this instruction,
                                              ' but if a client lives the next instruction will be ignored
       catch
          shell (sAppExe & sAppParameter, 1) ' only a shell-instruction can start a sclient.exe
          wait 10000
       endcatch
    end if
'///<li>The normal start routine (for FAT installed office or a network installed office)
'///+<ul><li>If you want to create a logfile for timestamps, the parameter <i>-env:RTL_LOGFILE=[Path]</i> is appended. (<u>Note</u>: On Win32 the path must have two backslashes)</li>
'///+<li>To ignore the crash- and recover- process for StarOffice-documents the parameter <i>-norestore</i> is also appended</li>
'///+<li>To disable the configuration lock dialog <i>-nolockcheck</i> is also appended</li>
'///+<li>To enable the automated testing <i>-enableautomation</i> has been added since SRX644k</li>
'///+<li>If you make a remote-test, the office process can't be started by the testtool; you would get an error message</li>
    try
       if gProflog = TRUE then                                  ' to start a office with profiling parameter
          if right (sProfPath, 1) <> gPathSigne then sProfPath = sProfPath + gPathSigne
          mkdir sProfPath                                       ' if the directory for profiling does not exists it will be created
          sParameter = "-env:RTL_LOGFILE=" + sProfPath + sProfParameter
          Start sAppExe, "-enableautomation -norestore -nolockcheck " + sAppParameter + sParameter + " " + sFactory
       else
         '------- WorkAround for UNIX --------(but doesn't harm windows :-) #106359#)
         sWorkAround = "-enableautomation -norestore -nolockcheck " + sAppParameter + " " + sFactory
         sWorkAround = fRemoveDoubleSpace (sWorkAround)
         '------------------------------------
         Start sAppExe, sWorkAround
       end if
    catch
       if gSamePC = FALSE then
          Exceptlog
          if MsgBox ("It is not possible to start StarOffice on a remote system." + Chr(10) + "Please start StarOffice.", 1, "Starting StarOffice") = 2 then end
       else
          Exceptlog
          if gClient = TRUE then
             if MsgBox ("The test has a problem to start the StarOffice-Client." + Chr(10) + "Please start the client and continue the test.", 1, "Starting StarOffice-Client") = 2 then end
          else
             if gNetzInst = TRUE then
                warnlog "The test has a problem to start StarOffice (workstation). It needs a second chance!"
             else
                warnlog "The test has a problem to start StarOffice. It needs a second chance!"
             end if
          end if
       end if
       wait 2000
   endcatch
'///+<li>Sometimes the first start instruction does not work correctly, so here it gets a second chance to start.</li></ul></li>
   if gClient = TRUE AND gClientUser <> "" then
      start sAppExe, sAppParameter
   else
      if gProflog = TRUE then                             ' to start a office with profiling parameter
         Start sAppExe, "-enableautomation -norestore -nolockcheck " + sAppParameter + sParameter + " " + sFactory
      else
         '------- WorkAround for UNIX --------(but doesn't harm windows :-) #106359#)
         sWorkAround = "-enableautomation -norestore -nolockcheck " + sAppParameter + " " + sFactory
         sWorkAround = fRemoveDoubleSpace (sWorkAround)
         '------------------------------------
         Start sAppExe, sWorkAround
      end if
   end if
   wait 3000

'///<li>set the debug output of an nonproduct StarOffice to the Testtool
   try
      CaptureAssertions TRUE            ' only in debug version of StarOffice : set the assertion output to testtool
   catch
   endcatch

'///<li>After starting, the text <b>The first doc</b> will be inserted on the first document per clipboard.
'///+<ul><li>This is a requirement because a new unchanged document will be replaced by a loaded document and that is not good for automated testing.</li></ul></li></ol>
   sleep(2)                              ' to change the first document
   SetClipboard "The first doc!"
   EditPaste
end sub

'-------------------------------------------------------------------------

sub ExitRestartTheOffice (optional sProfPath as String, optional sProfParameter as String)
'///ExitRestartTheOffice
'///+<ul><li><u>input</u>: <b>optional</b> <i>sProfPath</i> as String [path for profiling data]</li>
'///+<li><u>input</u>: <b>optional</b> <i>sProfParameter</i> as String [filename for profiling data]</li></ul>
'///+Exit and restart the office after 30 minutes
'///+<ul><li>If a messagebox comes up (yes, no) it will be closed (only one messagbox)</li></ul>

   sleep(2)
   FileExit
   try
      Kontext "Active"
      if Active.Exists(2) then Active.No
   catch
   endcatch

   sleep(28)
   if gProflog = TRUE then                                  ' to start a office with profiling parameter
      if right (sProfPath, 1) <> gPathSigne then sProfPath = sProfPath + gPathSigne
      mkdir sProfPath                                       ' if the directory for profiling does not exists it will be created
      sParameter = "-env:RTL_LOGFILE=" + sProfPath + sProfParameter
      Start sAppExe, "-enableautomation -norestore -nolockcheck " + sAppParameter + sParameter + " " + sFactory
    else
      Start sAppExe, "-enableautomation -norestore -nolockcheck " + sAppParameter + " " + sFactory
   end if
   sleep(2)                                        ' to change the first document
   SetClipboard "The first doc!"
   EditPaste
end sub

'-------------------------------------------------------------------------

sub TestEnter
'///<b>TestEnter</b>: Automatically called, when a testcase-routine starts
   Call PleaseRecover  ("TestEnter")
   gApplication = UCase (gApplication)
end sub

'-------------------------------------------------------------------------

sub TestExit
'///<b>TestExit</b>: Automatically called at the end of a testcase or directly called when an error occured
   Call PleaseRecover  ("TestExit")
end sub

'-------------------------------------------------------------------------

sub PleaseRecover (sWhat as String)
'///<b>PleaseRecover</b>: General recover routine
   Dim sError as String
   Dim sInterrupt as Boolean
   Dim sOtherError as Boolean

   sInterrupt = FALSE
   sOtherError = FALSE

'///+<ul><li>Close the translation window</li>
   try
      if gDasNicht = 0 then
         Kontext "TranslationWindow"
         if TranslationWindow.Exists then TranslationWindow.Close
      end if
   catch
   endcatch

'///+<li>use <i>ResetApplication</i> method</li>
   try
      sError = ResetApplication                       ' all error-strings are in sError
      if sError <> "" then                            ' if sError = "" then no error occured
         printlog "   **    Error in " + sWhat + " -Routine      **"
         warnlog sError
      end if
   catch
      printlog sError
      sInterrupt = TRUE
   endcatch

   try
      AppAbort                                        ' kill all commands after the reset
   catch
   endcatch

'///+<li>If the office crashes interrupt = TRUE and the office should be started again</li>
   if sInterrupt = TRUE AND gPortalTest <> TRUE then
      try
         hStartTheOffice
         SetClipboard " "
         EditPaste
      catch
         try
            if (MsgBox ("The base state for a test can't be reached!" + Chr(10) + "Please set the application into base state by yourself and press OK.", 17, sWhat + "-Routine")) = 2 then end
            warnlog "!!!  " + sWhat + " : The base state for a test can't be reached! The test didn't recover automatically.  !!!"
            hStartTheOffice
         catch
            ExceptLog
         endcatch
      endcatch

      try
         AppAbort                       ' kill all commands after the reset
      catch
      endcatch

   end if

   try
      CaptureAssertions TRUE            ' only in debug version of StarOffice : set the assertion output to testtool
   catch
   endcatch

'///+<li>Write the data for status page in a list - duration string is 00:00:00</li></ul>
   if gTestName <> "" AND sWhat = "TestExit" then
      hStatusWriteOutput ("00:00:00")
   end if
   Kontext
end sub

'-------------------------------------------------------------------------

sub hFirstOutput
'///<b>hFirstOutput</b>: Create a general header for all tests
  Dim sDir as String, sDir1 as String
   if gSamePC = TRUE then
      gVersionsnummer = FindBuildID
      iSystemSprache  = hGetSystemLanguage
      bDebugVersion   = IsDebugVersion
      'Detecting child workspaces (CWS) and mahler TT Framework server
      if InStr(gVersionsnummer , "[CWS:") <> 0 then
        gCWS = TRUE
       else
        gCWS = FALSE
        if hDetectMahlerFramework = TRUE then
          gMahler = TRUE
         else
          gMahler = FALSE
        end if
      end if
    else
      gVersionsnummer = "None"
      iSystemSprache  = 01
      bDebugVersion   = FALSE
   end if
   printlog "--------------------------------------------------"
   if bDebugVersion = TRUE then
      printlog "**  Build number                 : " + gVersionsnummer + "      debug"
   else
      printlog "**  Build number                 : " + gVersionsnummer
   end if
   if gCWS = FALSE then
      printlog "**  Build type                   : MASTER"
      if gMahler = TRUE then
       printlog    "**  Status Feature (mySQL)       : Enabled"
      end if
    else
      printlog "**  Build type                   : CWS"
   end if
   printlog    "**  Build number of hid.lst      : " + GetBuildNumHidLst

   if gClient = TRUE then
      if gClientUser <> "" then
         printlog "You are testing a client-server-version of StarOffice"
         printlog "**  Path to sclient-binary       : " + gsClient
         printlog "**  Client-User                  : " + gClientUser
         if gClientLaden = TRUE then
            printlog "**  Loading/Saving - serversite "
         else
            printlog "**  Loading/Saving - clientsite "
         end if
         printlog "You are testing a RVP-Office"
      end if
   end if

   if gNetzInst = TRUE then
      printlog "You are testing a networkinstallation of StarOffice"
      printlog "**  Path of networkinstallation  : " +  gNetzOfficePath
      printlog "**  Path of workstation          : " +  gOfficePath
    else
      printlog "**  OfficePath                   : " +  gOfficePath
   end if
   printlog "**  Started application          : " + sAppExe

   printlog "**  Officelanguage               : " + iSprache + "  (" + gLanguage + " / " + gISOLang + ")"
   printlog "**  Systemlanguage               : " + iSystemSprache + "  (" + GetLanguageText (iSystemSprache) + ")"
   if gSamePC = FALSE then
      printlog "**  Platform Testtool            : " + gtSYSName
      printlog "**  Platform Office              : " + gSYSName + "   (" + gHost + ") "
    else
      printlog "**  Testing Platform             : " + gtSYSName
   end if

   sDir1 = ConvertPath (gOfficePath + "user\work\"
   sDir = App.Dir (sDir1, 16)
   if sDir = "" then
      App.MKDir (sDir1)
      printlog "**  the work-dir at " +  sDir1 + " has been created!"
   end if

   gDasNicht = 1
   gbSnapShot = FALSE
   printlog "--------------------------------------------------"
end sub

'-------------------------------------------------------------------------

function FindBuildID as String
'///<b>FindBuildID</b>: Get BuildID out of bootstrap.ini/boostraprc
'///+or search in <i>.../program/resource/isoxxx??.res</i> for the BuildID.
  Dim sOfficePath as String

  if gNetzInst = TRUE then
     sOfficePath = gNetzOfficePath
   else
     sOfficePath = gOfficePath
  end if

   if gSamePC = TRUE then
      if gPlatgroup = "unx" then
         FindBuildID = GetIniValue (sOfficePath + "program/bootstraprc", "Bootstrap", "buildid")
       else
         FindBuildID = GetIniValue (sOfficePath + "program\bootstrap.ini", "Bootstrap", "buildid")
      end if
   end if

   if FindBuildID = "" then
     Dim FileNum, iStart, i as Integer
     Dim xmlZeile, sZ1, sZ2, sIsofile as String

      sIsofile = Dir (sOfficePath + "program" + gPathSigne + "resource" + gPathSigne + "iso*.res")


      if sIsofile = "" then
         sIsofile = App.Dir (sOfficePath + "program" + gPathSigne + "resource" + gPathSigne + "iso*.res")
      end if

      sIsofile = ConvertPath (sOfficePath + "program" + gPathSigne + "resource" + gPathSigne + sIsofile)

      if sIsofile= "" then
         warnlog "FindBuildID : No isoxxx??.res-file was found!"
         exit function
      end if

      FileNum = FreeFile

      Open sIsofile For Input As #FileNum
      do until EOF(#FileNum) = True

         line input #FileNum, xmlZeile

         for i=1 to 100
             if i=1 then
                sZ1 = left (xmlzeile, 2048)
             else
                sZ1 = left (sZ2, 2048)
             end if
             if sZ1 < 2048 then
                i=101
             else
                iStart = instr (1, sZ1, "Build", 1)
                if iStart <> 0 then
                   iStart = iStart-5
                   FindBuildID = Mid (sZ1, iStart, 16)
                   exit do
                end if
                sZ2 = right (sZ1, len (sZ1)-2048)
            end if
         next i
      loop
      Close #FileNum
   end if
end function

'-------------------------------------------------------------------------

function IsDebugVersion as Boolean
'///<b>IsDebugVersion</b>: Assertions if the tested OpenOffice.org is a debug- or a product version
'///+<ul><li>excecute the command with try/catch 'captureAssertions': it fails in product versions </li></ul>
   IsDebugVersion = FALSE
 ' works only in debug version of OpenOffice.org : set the assertion output to testtool
   try
      CaptureAssertions TRUE
      IsDebugVersion = TRUE
   catch
      IsDebugVersion = FALSE
   endcatch
end function

'-------------------------------------------------------------------------

function GetBuildNumHidLst as String
'///<b>GetBuildNumHidLst</b>: Get the BuildId out of the <i>hid.lst</i>
  Dim FileNum as Integer
  Dim xmlZeile as String

   if Dir (gtHidLstPath + "hid.lst") <> "" then
      FileNum = FreeFile
      Open (gtHidLstPath + "hid.lst") For Input As #FileNum
      do until EOF(#FileNum) = True
         line input #FileNum, xmlZeile
         GetBuildNumHidLst = Left (xmlZeile, 4)
         if GetBuildNumHidLst <> "" then exit do
      loop
      Close #FileNum
    else
      GetBuildNumHidLst = ""
   end if
end function

'-------------------------------------------------------------------------

sub mMakeGeneralOptions
   Dim iJump as Integer
   Dim sComXML as String, sHelpTip as String
   Dim bHelpTip as Boolean, Silent as Boolean
   dim sTempPath as string
   dim sTempList(10) as string

   Silent = TRUE

   try
      ToolsOptions

      call hToolsOptions ("Languagesettings", "Languages")
      gAsianSup = Aktivieren.IsChecked
      gCTLSup   = ComplexScriptEnabled.IsChecked

      if gAsianSup = TRUE then
         printlog "**  Asian language support       : enabled"
      end if

      if gCTLSup = TRUE then
         printlog "**  Complex scripts support      : enabled"
      end if

      ' set gAccessibility for windows (from options-UI) and unix (ask gconftool-2)
      if gPlatGroup = "unx" then
         try 'TODO: or VCL.xcu...Application::GetSettings().GetMiscSettings().GetEnableATToolSupport();
            sTempPath = ConvertPath (gOfficePath + "user\work\accessibility."
            if (dir(sTempPath+"txt") <> "") then
               kill (sTempPath+"txt")
            endif
            TextInDatei ("gconftool-2 -g /desktop/gnome/interface/accessibility > "+sTempPath+"txt", sTempPath+"sh")
            ' sadly the output to the console about a not found 'gconftool-2' can't be supressed,
            ' because every shell handels redirection of error output differently.
            shell ("sh "+sTempPath+"sh", 0, TRUE) ' WAIT until command is executed
            sTempList(0) = 0: sTempList(1) = 0
            if (dir(sTempPath+"txt") = "") then
               gAccessibility = FALSE
            else
               ListRead ( sTempList(), sTempPath+"txt")
               if (inStr (lCase(sTempList(1)), "true") > 0) then
                  gAccessibility = TRUE
               else
                  gAccessibility = FALSE
               endif
            endif
         catch
            gAccessibility = FALSE
         endcatch
      else
         call hToolsOptions ("STAROFFICE", "ACCESSIBILITY")
         try
            gAccessibility = SupportAssistiveTechnologyTools.IsChecked
         catch
            gAccessibility = FALSE
         endcatch
      endif
      if gAccessibility then
         printlog "**  Accessibility  support       : enabled"
      end if

      gCentralConfiguration = hgCentralConfiguration()
      if gCentralConfiguration then
         printlog "**  Central Configuration support: enabled"
      end if

      if gPlatGroup = "unx" then
         gUseSysDlg = FALSE
      else
         call hToolsOptions ("StarOffice", "General")
         StarOfficeDialogeBenutzen.Check
         gUseSysDlg = FALSE
         printlog "**  StarOffice use internal file-dialogs on windows-systems (master.inc)"
      end if

      call hToolsOptions ("StarOffice", "Paths")
      select case iSprache
         case 01   : iJump = 11      ' English (USA)
         case 03   : iJump =  0      ' Portuguese
         case 07   : iJump =  0      ' Russian
         case 30   : iJump =  0      ' Greek
         case 31   : iJump =  0      ' Netherlands
         case 33   : iJump = 10      ' French
         case 34   : iJump = 10      ' Spanish
         case 35   : iJump =  0      ' Finnish
         case 36   : iJump =  0      ' Hungaria
         case 37   : iJump =  0      ' Catalan
         case 39   : iJump =  4      ' Italian
         case 42   : iJump =  0      ' Czech
         case 43   : iJump =  0      ' Slowak
         case 44   : iJump =  0      ' English (GB)
         case 45   : iJump =  0      ' Danish
         case 46   : iJump =  4      ' Swedish
         case 47   : iJump =  0      ' Norwegian
         case 48   : iJump =  0      ' Polish
         case 49   : iJump =  2      ' German
         case 51   : iJump =  0      ' Slowak
         case 55   : iJump =  0      ' Portuguese (Brazil)
         case 66   : iJump =  14     ' Thai
         case 81   : iJump =  0      ' Japanese ' disabled, because locale dependant!
         case 82   : iJump =  0      ' Korean   ' disabled, because locale dependant!
         case 86   : iJump =  0      ' Chinese (simplified)  ' disabled, because locale dependant!
         case 88   : iJump =  0      ' Chinese (traditional) ' disabled, because locale dependant!
         case 90   : iJump =  0      ' Turkish
         case 91   : iJump =  0      ' Hindi
         case 96   : iJump =  16     ' Arab
         case 97   : iJump =  0      ' Hebrew
         case else : warnlog "The work-dir can't changed to the internal office-work-dir! Please insert the language in this list!"
                     iJump =  0
      end select

      if iJump <> 0 then
         'DEBUG: printlog "**  master.inc::mMakeGeneralOptions::iJump(" & iSprache & ") = " & iJump
         Typ.TypeKeys " <HOME>"
         Typ.TypeKeys "<DOWN>", iJump-1
         Bearbeiten.Click
         Kontext "OeffnenDlg"
         Pfad.SetText (ConvertPath (gOfficePath + "user\work\"))
         Auswaehlen.Click
         printlog "**  work-directory has been changed to internal work-dir in staroffice"
        else
           if (bAsianLan = FALSE) then
               qaerrorlog "**  master.inc::mMakeGeneralOptions::iJump(" & iSprache & ") has not been defined."
               qaerrorlog "**  Please find find out which entry number is the path entry under Tools / Options / StarOffice / Paths."
               qaerrorlog "**  The number has to be entered as iJump variable in master.inc -> mMakeGeneralOptions!"
           endif
      end if
      sleep(1)

      if gPlatgroup = "unx" then
       call hToolsOptions ("StarOffice", "General")
      end if
      sleep(1)
      Kontext "ExtrasOptionenDlg"
      ExtrasOptionenDlg.OK
      sleep(4)

   catch
      ExceptLog
      ResetApplication
   endcatch

   if gNetzInst = TRUE then
      sComXML = gNetzOfficePath + ConvertPath ("user\registry\data\org\openoffice\Office\Common.xcu")
   else
      sComXML = gOfficePath + ConvertPath ("user\registry\data\org\openoffice\Office\Common.xcu")
   end if

   if app.Dir (sComXML) = "" then
      bHelpTip = TRUE
   else
      sHelpTip = GetXMLValue (sComXML, "oor:node", "node oor:name="+ Chr(34) + "Help"+Chr(34) + ";prop oor:name="+Chr(34) + "Tip" + Chr(34)+ ";value", Silent)
      if sHelpTip = "" then
         bHelpTip = TRUE
      else
         bHelpTip = sHelpTip
      end if
   end if

   if bHelpTip = TRUE then
      printlog "**  Help/Tip is now disabled"
      HelpTips
   end if

   printlog "--------------------------------------------------"
   printlog ""

end sub

'-------------------------------------------------------------------------

function hgCentralConfiguration as boolean
'///<b>hgCentralConfiguration</b>: Discover if Central Configuration via Ldap is enabled.
'///+<ul><li>Criteria: If file <i>program/configmgr[.ini|rc]</i> exists an contains <i>CFG_BackendService=com.sun.star.comp.configuration.backend.*SingleBackend</i> in section <i>Bootstrap</i></li>
'///+<li>TRUE if * = LDAP</li>
'///+<li>else FALSE</li>
'///+<li>default *: Local</li></ul>
   dim i as integer
   dim sFile as string
   dim iTemp as integer
   dim iTemp2 as integer
   dim sTemp as string
   dim sTemp2 as string

   hgCentralConfiguration = FALSE

   if gNetzInst then
      sFile = gNetzOfficePath
    else
      sFile = gOfficePath
   endif
   sFile = sFile + "program/configmgr"
   if gPlatgroup <> "unx" then
      sFile = sFile + ".ini"
    else
      sFile = sFile + "rc"
   endif
   sFile = ConvertPath (sFile)

   sTemp = GetIniValue(sFile, "Bootstrap", "CFG_BackendService")
   if (sTemp <> "") then
'      printlog "DEBUG: '" + sTemp + "'"
      iTemp = inStr(sTemp, "com.sun.star.comp.configuration.backend.")
      iTemp2 = inStr(sTemp, "SingleBackend")
      if ((iTemp > 0) AND (iTemp2 > 0)) then
         sTemp2 = mid(sTemp, iTemp+40, len(sTemp)-53)
'         printlog "DEBUG: '" + sTemp2 + "'"
         if (sTemp2 = "Ldap") then
            hgCentralConfiguration = TRUE
         endif
       else
         warnlog "ERROR finding CentralConfiguration."
      endif
   endif
end function

'-------------------------------------------------------------------------

function hIsResultWriteable() as boolean
'///<b>hIsResultWriteable</b>: Running a test without being able to write the RESULT file to disk is worthless.
'///+This functions checks if the directory exists, tries to create it and checks if it is writeable.
'///+If this fails, the test won't start and presents a messagebox.
   dim sResultFilePath as string
   dim sTestDir as string

'///Get the path to the RESULT directory
'? Results_=
   sResultFilePath = GetIniValue (gTesttoolIni, gTTProfileName , "LogBaseDir")
   if (dir(sResultFilePath, 16) = "") then ' doesn't exist
      ' try to create it
      try
         MkDir (ConvertPath(sResultFilePath))
         MkDir (ConvertPath(sResultFilePath)+gPathsigne+"ID104037") ' WorkAround for bug in dir() #104037#
         if (dir(sResultFilePath, 16) <> "") then ' does exist
            hIsResultWriteable = TRUE
            printlog "master.inc::hIsResultWriteable():: created RESULT directory: '" + sResultFilePath + "'"
            RmDir (ConvertPath(sResultFilePath)+gPathsigne+"ID104037") ' WorkAround for bug in dir()
          else
            warnlog "make the directory '" + sResultFilePath + "' writeable; RESULT file can not be saved;"
            hIsResultWriteable = FALSE
         endif
       catch
         warnlog "create the directory '" + sResultFilePath + "'; RESULT file can not be saved; (no right to create the directory :-()"
         hIsResultWriteable = FALSE
      endcatch
   else
      ' check if it is writeable
      try
         sTestDir = "tbotest"   ' nasty bug, if the path is with a path sign at the end; usually on on windows root dirs :-(
         if (right(ConvertPath(sResultFilePath),1) <> gPathSigne) then
            sTestDir = gPathSigne + sTestDir
         endif
         MkDir (ConvertPath(sResultFilePath + sTestDir))
         RmDir (ConvertPath(sResultFilePath + sTestDir))
         hIsResultWriteable = TRUE
      catch
         warnlog "make the directory '" + sResultFilePath + "' writeable; RESULT file can not be saved;"
         hIsResultWriteable = FALSE
      endcatch
   endif
end function

function fRemoveDoubleSpace(stringToChange as string) As String
   '------- WorkAround for UNIX --------(but doesn't harm windows :-) #106359#)
   'Removes every space' after a 'space'
   Dim lLength, n As Long
   Dim sNextLetter As String
   Dim sLastLetter As String
   Dim sFinalString As String
   Dim sTxt, sChar As String

   sTxt = stringToChange 'store all arguments in
   lLength = Len(sTxt)
   sLastLetter = left(sTxt, 1)
   sFinalString = sLastLetter

   For n = 2 To lLength Step 1
      sNextLetter = Mid(sTxt, n, 1)
      If ("  " <> sLastLetter + sNextLetter) Then
         sFinalString = sFinalString + sNextLetter
      End If
      sLastLetter = sNextLetter
   Next n
   fRemoveDoubleSpace = sFinalString
End Function

'-------------------------------------------------------------------------

sub hDetectMahlerFramework as Boolean
'/// Detecting the mahler TT Framework server.
 Dim OurFile as string
  hDetectMahlerFramework = FALSE
   OurFile = Dir (ConvertPath (gTestToolPath & "errorlog\mahler\mahler.inf"))
   if OurFile = "mahler.inf" then
    hDetectMahlerFramework = TRUE
   end if
end sub

'-------------------------------------------------------------------------

