'*************************************************************************
'*
'*  $RCSfile: t_menu.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:39 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/*****************************************************************
'*
'* Owner : thorsten.bosbach@sun.com
'*
'* short description : wrappers for accessing menues (context-, bar-, button- menues)
'*
'***********************************************************************************
' #1 hMenuItemGetCount
' #1 hMenuSelectNr
' #1 hMenuItemCheck
' #1 hMenuItemUnCheck
' #1 hMenuItemIsChecked
' #1 hMenuItemIsEnabled
' #1 hMenuItemGetText
' #1 hMenuItemGetTextMitTilde
' #1 hMenuGetTextList
' #1 hMenuGetTextListMitTilden
' #1 hMenuGetListOhneTilde
' #1 hMenuGetTildenList
' #1 hhEntferneTilde
' #1 hMenuGetItemCommand
' #1 hWindowGetCount
' #1 hWindowGetIndex
' #1 hWindowGetText
' #1 hWindowSelect
' #1 hUseMenu
' #1 hMenuClose
' #1 hOeffneNeuImMenue
' #1 hOeffneEinstellungenImMenue
' #1 hOeffneImMenue
'\*****************************************************************

function hMenuItemGetCount as Integer
'/// OUTPUT: number of entries in the activated menu (without seperators) ///'
'///+ menu left open ///'
 Dim i, j, Ende, nID as Integer
   Sleep 2

   j=0
   for i=1 to MenuGetItemCount
      if NOT MenuIsSeperator ( i ) then j=j+1
   next i
   hMenuItemGetCount = j
end function

function hMenuSelectNr ( EintragsNr as Integer ) as String
'/// INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: text of the entry ///'
 Dim i, j, RealEnd, Ende, nID as Integer
   Sleep 2

   Ende = EintragsNr
   RealEnd = MenuGetItemCount
   if Ende > RealEnd then
      Warnlog "hMenuSelectNr canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr+j )
   hMenuSelectNr = MenuGetItemText ( nID )
   MenuSelect ( nID )
end function

function hMenuItemCheck ( EintragsNr as Integer ) as String
'/// check the menu item (if it is checked, it stays checked) ///'
'///+ INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: text of the entry ///'
 Dim i as Integer, j as Integer, RealEnd as Integer, Ende as Integer, nID as Integer

   Ende = EintragsNr
   RealEnd = hMenuItemGetCount
   if Ende > RealEnd then
      Warnlog "hMenuItemCheck canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr+j )
   hMenuItemCheck = MenuGetItemText ( nID )
   if NOT MenuIsItemChecked ( nID ) then
      MenuSelect ( nID )
   else
      hMenuClose
   end if
end function

function hMenuItemUnCheck ( EintragsNr as Integer ) as String
'/// UNcheck the menu item (if it is UNchecked, it stays UNchecked) ///'
'///+ INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: text of the entry ///'
 Dim i, j, RealEnd, Ende, nID as Integer

   Ende = EintragsNr
   RealEnd = hMenuItemGetCount
   if Ende > RealEnd then
      Warnlog "hMenuItemUnCheck canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr+j )
   hMenuItemUnCheck = MenuGetItemText ( nID )
   if MenuIsItemChecked ( nID ) then
      MenuSelect ( nID )
   else
      hMenuClose
   end if
end function

function hMenuItemIsChecked ( EintragsNr as Integer ) as Boolean
'/// is the the menu item checked ? ///'
'///+ INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: True = yes!, False = no! ///'
 Dim i, j, Ende, RealEnd, nID as Integer

   Ende = EintragsNr
   RealEnd = hMenuItemGetCount
   if Ende > RealEnd then
      Warnlog "hMenuItemIsChecked canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr + j )
   hMenuItemIsChecked = MenuIsItemChecked ( nID )
end function

function hMenuItemIsEnabled ( EintragsNr as Integer ) as Boolean
'/// is the the menu item enabled (not greyed out) ? ///'
'///+ INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: True = yes!, False = no! ///'
'///+ menu left open ///'
 Dim i, j, Ende, RealEnd, nID as Integer

   Ende = EintragsNr
   RealEnd = MenuGetItemCount
   if Ende > RealEnd then
      Warnlog "hMenuItemIsEnabled canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr + j )
   hMenuItemIsEnabled = MenuIsItemEnabled ( nID )
end function

function hMenuItemGetText ( EintragsNr as Integer ) as String
'///+ INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: text of item without tilde ///'
'///+ menu left open ///'
 Dim i, j, RealEnd, Ende, nID as Integer

   Ende = EintragsNr
   RealEnd = MenuGetItemCount
   if Ende > RealEnd then
      Warnlog "hMenuItemGetText canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr + j )
   hMenuItemGetText = hhEntferneTilde ( MenuGetItemText ( nID ) )
end function

function hMenuItemGetTextMitTilde ( EintragsNr as Integer ) as String
'/// INPUT : number of entry from the top (>=1)///'
'///+ OUTPUT: text of item with tilde (which indicates the shortcurt of the entry)///'
'///+ menu left open ///'
 Dim i, j, RealEnd, Ende, nID as Integer

   Ende = EintragsNr
   RealEnd = MenuGetItemCount
   if Ende > RealEnd then
      Warnlog "hMenuItemGetTextMitTilde canceled: Entry number "+ Ende +" does not exists, because there are only " + RealEnd + "  entries! "
      hMenuClose
      exit function
   end if
   j=0
   for i=1 to Ende
      if MenuIsSeperator ( i+j ) then j = j+1
   next i
   nID = MenuGetItemID ( EintragsNr + j )
   hMenuItemGetTextMitTilde = MenuGetItemText ( nID )
end function

function hMenuGetTextList ( lsEintragsliste() as String ) as Integer
'/// INPUT : a 'list-variable' aka string array; ///'
'///+ OUTPUT: number of entries in the menue/list; the list-variable contains now the strings of the menu (withOUT tildes) ///'
'///+ menu left open ///'
 Dim i, j, nID as Integer
 Dim Eintrag as String

   lsEintragsListe(0) = 0
   j=0
   for i=1 to MenuGetItemCount
      if NOT MenuIsSeperator ( i ) then
         nID = MenuGetItemID ( i )
         Eintrag = hhEntferneTilde ( MenuGetItemText ( nID ) )
         ListAppend ( lsEintragsListe(), Eintrag )
         j=j+1
      end if
   next i
   hMenuGetTextList = j
end function

function hMenuGetTextListMitTilden ( lsEintragsliste() as String ) as Integer
'/// INPUT : a 'list-variable' aka string array; ///'
'///+ OUTPUT: number of entries in the menue/list; the list-variable contains now the strings of the menu (with tildes) ///'
'///+ menu left open ///'
 Dim i, j, nID as Integer
 Dim Eintrag as String

   lsEintragsListe(0) = 0
   j=0
   for i=1 to MenuGetItemCount
      if NOT MenuIsSeperator ( i ) then
         nID = MenuGetItemID ( i )
         Eintrag = MenuGetItemText ( nID )
         ListAppend ( lsEintragsListe(), Eintrag )
         j=j+1
      end if
   next i
   hMenuGetTextListMitTilden = j
end function

function hMenuGetListOhneTilde ( lsEintragsliste() as String ) as Integer
'/// put the entries of the menues in a list that don't have a tilde -> BUG ///'
'///+ INPUT : a 'list-variable' aka string array; ///'
'///+ OUTPUT: number of entries without a tilde; the list-variable contains now the strings of the menu without tildes ///'
'///+ menu left open ///'
 Dim i, j, nID as Integer
 Dim Eintrag as String

   lsEintragsListe(0) = 0
   j=0
   for i=1 to MenuGetItemCount
      if NOT MenuIsSeperator ( i ) then
         nID = MenuGetItemID ( i )
         Eintrag = MenuGetItemText ( nID )
         if Eintrag = ( hhEntferneTilde ( Eintrag ) ) then
            ListAppend ( lsEintragsListe(), Eintrag )
            j=j+1
         end if
      end if
   next i
   hMenuGetListOhneTilde = j
end function

function hMenuGetTildenList ( lsEintragsliste() as String ) as Integer
'/// put the entries of the menues in a list that HAVE a tilde ///'
'///+ INPUT : a 'list-variable' aka string array; ///'
'///+ OUTPUT: number of entries a tilde; the list-variable contains now the strings of the menu with tildes ///'
'///+ menu left open ///'
 Dim i, j, nID, Stelle as Integer
 Dim Eintrag as String

   lsEintragsListe(0) = 0
   j=0
   for i=1 to MenuGetItemCount
      if NOT MenuIsSeperator ( i ) then
         nID = MenuGetItemID ( i )
         Eintrag = MenuGetItemText ( nID ) + " - "
         Stelle = Instr ( 1, Eintrag, "~", 1 )
         if Stelle <> 0 then
            Eintrag = Eintrag + Mid ( Eintrag, Stelle, 2 )
         end if
         ListAppend ( lsEintragsListe(), Eintrag )
         j=j+1
      end if
   next i
   hMenuGetTildenList = j
end function


sub hMenuClose
'/// close menue ///'
    MenuSelect ( 0 )
end sub

' ***************************************************************************
' ************                subroutines                *****************
' ***************************************************************************

function hhEntferneTilde ( sEintrag as String ) as String
'///+ INPUT : string with tilde ///'
'///+ OUTPUT: string without tilde ///'
 Dim i
   i = Instr ( 1, sEintrag, "~", 1 )
   if i <> 0 then
      hhEntferneTilde = Left ( sEintrag, i-1 ) + Right ( sEintrag, ( Len(sEintrag) - i ) )
   else
      hhEntferneTilde = sEintrag
   end if
end function

sub hOeffneNeuImMenue
'/// open the entry 'new' in all languages in a menu ///'
'///+ menue has to be opened before! ///'
 Dim SpracheNeu as string
 Dim Treffer as string
 Dim y, GrossesEnde, openID as integer

   select case iSprache
      case 01   : SpracheNeu = "New"
      case 03   : SpracheNeu = "Novo"
      case 31   : SpracheNeu = "Nieuw"
      case 33   : SpracheNeu = "Nouveau"
      case 34   : SpracheNeu = "Nuevo"
      case 39   : SpracheNeu = "Nuovo"
      case 46   : SpracheNeu = "Nytt"
      case 49   : SpracheNeu = "Neu"
      case else : warnlog "Sprache nicht aufgenommen in hOeffneImMenue!!!!"
   end select
   GrossesEnde = MenuGetItemCount

   for y=1 to GrossesEnde-1
      Treffer = hMenuItemGetText ( y )
        if InStr ( Treffer , SpracheNeu ) > 0 then
          Exit For
        end if
   next y
   hMenuSelectNr ( y )
end sub

sub hOeffneEinstellungenImMenue
'/// open the entry 'Properties' in all languages in a menu ///'
'///+ menue has to be opened before! ///'
   Dim SpracheEinstellungen as string
   Dim Treffer as string
   Dim y, GrossesEnde, openID as integer

   select case iSprache

      case 01   : SpracheEinstellungen = "Properties"
      case 03   : SpracheEinstellungen = "Eigenschaften"
      case 31   : SpracheEinstellungen = "Eigenschappen"
      case 33   : SpracheEinstellungen = "Prop"
      case 34   : SpracheEinstellungen = "Eigenschaften"
      case 39   : SpracheEinstellungen = "Propriet"
      case 46   : SpracheEinstellungen = "Egenskaper"
      case 49   : SpracheEinstellungen = "Eigenschaften"
      case else : warnlog "Sprache nicht aufgenommen in hOeffneEinstellungenImMenue!!!!"

   end select
   GrossesEnde = MenuGetItemCount

   for y=1 to GrossesEnde-1
      Treffer = hMenuItemGetText ( y )
        if InStr ( Treffer , SpracheEinstellungen ) > 0 then
          Exit For
        end if
   next y
   hMenuSelectNr ( y )
end sub

sub hOeffneImMenue ( OeffneDas$ )
'/// open an entry in in a menu ///'
'///+ INPUT: string of emntry to open ///'
'///+ menue has to be opened before! ///'
Dim Treffer as string
   Dim y, GrossesEnde, openID as integer
   GrossesEnde = MenuGetItemCount

   for y=1 to GrossesEnde-1
      Treffer = hMenuItemGetText ( y )
        if InStr ( Treffer , OeffneDas$ ) > 0 then
          Exit For
        end if
   next y
   hMenuSelectNr ( y )
   sleep(2)
end sub

'-------------------------------------------------------------------------

function hMenuGetItemCommand ( EintragsNr as Integer ) as String
'/// <u>hMenuGetItemCommand(Nr)</u> ///
'///+ To read the slot/UNO slot which is behind a menu item. ///
'///+ Seperators will be ignored for the input INTEGER!
'///+ <b>[UNTESTED]</b>
   Dim i as integer
   Dim j as integer
   Dim RealEnd as integer
   Dim DasEnde as integer
   Dim nID as Integer
   sleep(2)
   DasEnde = EintragsNr
   RealEnd = MenuGetItemCount
   if DasEnde > RealEnd then
      warnlog "Parameter (" & DasEnde & ") bigger than items in menu (" & RealEnd & ") , 'hMenuGetItemCommand' canceled."
     else
      j=0
      for i=1 to DasEnde
       if MenuIsSeperator ( i+j ) then
        j = j+1
       end if
      next i
      nID = MenuGetItemID ( EintragsNr+j )
      hMenuGetItemCommand = MenuGetItemText ( nID )
      MenuGetItemCommand ( nID )
   end if
'   hMenuClose
end function

'-------------------------------------------------------------------------


'/// Functions for the lower part of the 'Window' Menu ///'
'///+ philosophie: you can't do any actions on the first document -> it get's the number 0 and it doesn't count ///'
'///+ so the first window you can work with gets the number 1 and counting starts with 1 ... ///'

'///<b> function hUseMenu () </b>///'
'///+ very global function: depends on 'gApplication' just activates the menu-bar ///'

'///<b> function hWindowGetCount () as integer </b>///'
'///+ returns the number of windows (all inclusive the first one!) ///'

'///<b> function hWindowGetIndex () as integer </b>///'
'///+ returns the number of the active window ///'

'///<b> function hWindowGetText (optional iWindow as integer) as string </b>///'
'///+ returns the text of the menu entry without the tilde: ///'
'///+ w/ calling parameter: the active window ///'
'///+ w/o calling parameter: the window i ///'

'///<b> function hWindowSelect (iWindow as integer) </b>///'
'///+ switches to the window i ///'
'///+ calling parameter: id of the window to activate ///'

function hWindowGetCount () as integer
'///<b> function hWindowGetCount () as integer </b>///'
'///+ returns the number of windows ///'

   'uShort GetDocumentCount() ' testool command
   hWindowGetCount = GetDocumentCount()
end function

function hWindowGetIndex () as integer
'///<b> function hWindowGetIndex () as integer </b>///'
'///+ returns the number of the active window ///'
   dim iMenues as integer      ' takes the number of entries in the windows menue
   dim iNotWindows as integer  ' number of open windows
   dim iKandidate as integer
   dim i as integer

   iNotWindows = hWindowGetCount ()
   hUseMenu()

   iMenues = hMenuItemGetCount
   hMenuSelectNr(iMenues-1)    ' 'windows' ist usually the one before the last
   wait 200
   iKandidate = 0
   iMenues = hMenuItemGetCount
   for i = ((iMenues - iNotWindows) + 1) to iMenues
      if (hMenuItemIsChecked (i)) then
         if (iKandidate = 0) then
            iKandidate = i
         else
            Warnlog "unexpected error 4711 - more than one window active??!! hWindowGetIndex () "
         endif
      endif
   next i
   iMenues = (iKandidate - (iMenues - iNotWindows) - 1)
   hMenuClose

   hWindowGetIndex = iMenues
end function

function hWindowGetText (optional iWindow as integer) as string
'///<b> function hWindowGetText (optional iWindow as integer) as string </b>///'
'///+ returns the text of the menu entry without the tilde: ///'
'///+ w/ calling parameter: the active window ///'
'///+ w/o calling parameter: the window i ///'
   dim iMenues as integer      ' takes the number of entries in the windows menue
   dim iNotWindows as integer  ' number of open windows
   dim iUseWindow


   if (isMissing(iWindow) = FALSE) then
      iUseWindow = iWindow
   else
      iUseWindow = hWindowGetIndex()
   endif

   iNotWindows = hWindowGetCount ()
   hUseMenu()

   iMenues = hMenuItemGetCount
   hMenuSelectNr(iMenues-1)    ' 'windows' ist usually the one before the last
   wait 200
   iMenues = hMenuItemGetCount
   hWindowGetText = hMenuItemGetTextMitTilde (iUseWindow + (iMenues - iNotWindows) + 1)
   hWindowGetText = hhEntferneTilde(hWindowGetText)
   hMenuClose
end function

function hWindowSelect (iWindow as integer)
'///<b> function hWindowSelect (iWindow as integer) </b>///'
'///+ switches to the window i ///'
'///+ calling parameter: id of the window to activate ///'
   dim iMenues as integer      ' takes the number of entries in the windows menue
   dim iNotWindows as integer  ' number of open windows

   iNotWindows = hWindowGetCount ()
   hUseMenu()

   'ActivateDocument iNumber as integer ' is a testtool command, but there is no system that stays behind iNumber :-[
   iMenues = hMenuItemGetCount
   hMenuSelectNr(iMenues-1)    ' 'windows' ist usually the one before the last
   wait 200
   iMenues = hMenuItemGetCount
   hMenuSelectNr (iWindow + 1 + (iMenues - iNotWindows))
end function

function hUseMenu ()
'///<b> function hUseMenu () </b>///'
'///+ very global function: depends on 'gApplication' just activates the menu-bar ///'
   Select Case Ucase(gApplication)
      Case "WRITER"
         Kontext "DocumentWriter"
         DocumentWriter.UseMenu

      Case "MASTERDOC"
         Kontext "DocumentMasterDoc"
         DocumentMasterDoc.UseMenu

      Case "HTMLDOKUMENT"
         Kontext "DocumentWriterWeb"
         DocumentWriterWeb.UseMenu

      case "CALC" ' there are 2 entries over :-( usually only one, html 0 :-((((
         Kontext "DocumentCalc"
         DocumentCalc.UseMenu

      case "DRAW"
         Kontext "DocumentDraw"
         DocumentDraw.UseMenu

      case "IMPRESS"
         Kontext "DocumentImpress"
         DocumentImpress.UseMenu

      case "MATH" :
         Kontext "DocumentMath"
         DocumentMath.UseMenu
   end select
end function

