'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: id_tools.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:26 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/*****************************************************************
'*
'* Owner : thorsten.bosbach@sun.com
'*
'* short description : some tools
'*
'******************************************************************
' #1 hSetSpellHypLanguage
' #1 hFindSpellHypLanguage
' #1 GetDecimalSeperator
' #1 TBOrestart
' #1 StrToDouble
' #1 GetMeasUnit
' #1 LiberalMeasurement
'\*****************************************************************

sub hSetSpellHypLanguage
   dim sTrieit as string
   if bAsianLan then
      Printlog " To make it to work, I have to change the default languge in the options! FOR CURRENT DOCUMENT ONLY!!!!!"
      ToolsOptions
         hToolsOptions ("LANGUAGESETTINGS","LANGUAGES")
         AktuellesDokument.Check
         if glLocale (4) = "" then
            qaErrorLog "Choose a spellbook from the list below and insert it into the file <\testtool\input\graphics\tools\locale_1.txt> on position (4) (only enabled for asian languages!) - '"+glLocale(4)+"'"
            Kontext "ExtrasOptionenDlg"
            ExtrasOptionenDlg.Cancel
            sTrieit = hFindSpellHypLanguage
            ToolsOptions
               hToolsOptions ("LANGUAGESETTINGS","LANGUAGES")
               AktuellesDokument.Check
            if sTrieit <> "" then
               Westlich.Select sTrieit
            else
               warnlog "Sorry no spellbook found :-("
            endif
         else
            printlog glLocale (4)
            Westlich.Select glLocale (4)
         endif
         printlog "selected: "+Westlich.GetSelText
         Kontext "ExtrasOptionenDlg"
         ExtrasOptionenDlg.OK
   endif
end sub

sub hFindSpellHypLanguage as string
  dim iListLength as integer
  dim i as integer

   if bAsianLan then
      ToolsOptions                                             ' take length of list
         hToolsOptions ("LANGUAGESETTINGS","WRITINGAIDS")
         SprachmoduleBearbeiten.click
            kontext "ModuleBearbeiten"
            for i = 1 to Sprache.GetItemCount
               Sprache.Select i
               sleep 1
               Printlog " "+i+": '"+Sprache.GetSelText +"'"
               if i = 1 then hFindSpellHypLanguage = Sprache.GetSelText
            next i
         ModuleBearbeiten.Close
      Kontext "ExtrasOptionenDlg"
      ExtrasOptionenDlg.OK
      sleep 1
   endif
end sub

function GetDecimalSeperator ( sDummy$ ) as String
'/// Input : number with fractionmark from 'NumericField' as String ///'
'///+ Output: '.' or ',' as String                                  ///'
   dim i1, i2 as integer

' get position of fraction mark / get IT
   i1 = instr (sDummy$, ",")
   i2 = instr (sDummy$, ".")
   if i1 > i2 then GetDecimalSeperator = "," else GetDecimalSeperator = "."
end function

sub TBOrestart
   hCloseDocument
   sleep (5)
  try  ' If Office has been exited ttool throws exception setting contect to msgbox (HDE)
   FileExit
   Kontext "Active"
   ' If first document has been modified, messagebox has to be closed
   if Active.Exists then
    if Active.GetRT = 304 then
     try
      Active.No
     catch
     endcatch
    endif
   endif
  catch
  endcatch
  sleep (30)   ' maybe checking if removed from task mgr ?
  Start sAppExe
   sleep (10)
   hNewDocument
   sleep (5)
end sub

function LiberalMeasurement ( sShould$, sActual$) as Boolean
'/// Input : (1. Should, 2. Actual) as Number with or without MeasurementUnit 'NumericField' as String ///'
'///+          if input has no MeasurementUnit i take it as 'cm' (was the default in old tests) ///'
'///+ Output: Boolean are they likely the same?
'/// NEEDED: mathematical proofment of iTolerance, by now just some guesses :-| ///'
'/// reason for this function:///'
'///+   because SO counts internaly in 'twip???s' 'twentieth of a point' there are some rounding errors ///'
'///+ there are also some rounding errors because of the internal representatio of floating point numbers in computers ///'
'///+   now lets try to get rid of them and have a nicer output in tests... ///'
   dim iTolerance as Double

   LiberalMeasurement = False ' worst case

' trivial
   if (sShould$ = sActual$) then
      LiberalMeasurement = True
   else
      ' check if measunit is the same !!
      if (GetMeasUnit(sShould$) <> GetMeasUnit(sActual$) ) then
         warnlog "In function LiberalMeasurement the measUnit is different, compare not possible yet"
      else
        ' set factor for liberality ;-)
         select case GetMeasUnit(sShould$)
            case "mm" : iTolerance = 0.1
            case "cm" : iTolerance = 0.04
            case chr$(34) : iTolerance = 0
            case "pi" : iTolerance = 0.01
            case "pt" : iTolerance = 0.1
            case "" : iTolerance = 0.03 ' cm is presubposition in old functions
         case else
            iTolerance = 0
            warnlog "This Unit is not available in this function"
         end select
         ' have to get the measurem unit, cause the offset is different for each :-(
         if ( (StrToDouble(sShould$) + iTolerance) >= StrToDouble(sActual$) ) AND ((StrToDouble ( sShould$ ) - iTolerance) <= StrToDouble ( sActual$ )) then
             LiberalMeasurement = True
         else
            LiberalMeasurement = False
            'printlog "LM: ---------------------------: "+sShould$ +":"+sActual$
         end if
         'printlog "### LibMeas: "+ (StrToDouble(sShould$) + iTolerance) +" - "+ StrToDouble(sShould$) +" - "+ (StrToDouble ( sShould$ ) - iTolerance)+" ; '"+GetMeasUnit(sShould$)+"'"
      end if
   end if
'      Printlog "+++++++++++++++++++++++++++++++++++++meas lib was here: "+LiberalMeasurement
end function

function GetMeasUnit ( sWert$ ) as String
'/// Input : Number with or without MeasurementUnit 'NumericField' as String ///'
'///+ Output: Initials of MeasurementUnit as String or "" when only a number ///'

'/// first lets check, if there is a number -> no unit there ///
   if isNumeric (right (sWert$, 1)) then
      GetMeasUnit = ""
   else
      '/// the only single character is '"' all others are two chars ///
      if (  StrComp (right (sWert$, 1), chr$(34) ) = 0 ) then
         GetMeasUnit = right (sWert$, 1)
      else
         GetMeasUnit = right (sWert$, 2)
      end if
   end if
end function


function StrToDouble ( sWert$ ) as Double
  Dim sDummy$
  dim i, i1, i2 as integer
  dim a as integer
  dim b as integer
  dim c as double
  dim n as integer

'/// Input : {'a[. ,]b[mm cm " pi pt]' with a, b as integer} as String ///'
'///+ Output: a[. , ]b as double ///'

' get rid of measure unit, the only single character is '"' all others are two chars
' there was a problem, if there is NO meas.unit!!!
      if (isNumeric (sWert$) = FALSE) then
         if (  StrComp (right (sWert$, 1), chr$(34) ) = 0 ) then
            sDummy$ = Left ( sWert$, Len(sWert$)-1 )
         else
            sDummy$ = Left ( sWert$, Len(sWert$)-2 )
         endif
      else
         sDummy$ = sWert$
      endif
   ' get position of fraction mark
      i1 = instr (sDummy$, ",")  ' wrong output
      i2 = instr (sDummy$, ".")
      if i1 > i2 then i = i1 else i = i2
        ' in front of decimal seperator
         try
            a = val (left (sDummy$,i-1))
         catch
            'printlog sWert$ + ":" + sDummy$ + ":" + i + ":" + i1+ ":" + i2
         endcatch
      ' after the decimal seperator
         n = (len (sDummy$)-i)
         b = val (right (sDummy$, n) )
         c = b * 10 ^ -n
         'printlog "-------------- :"+sWert$ +" :'"+a+"' :"+n+" :"+b+" :'"+c+"':"
         StrToDouble = a + c
end function

sub hTBOtypeInDoc
   hRechteckErstellen ( 10, 10, 30, 40 )
end sub

